/*
 * Copyright (c) 2010 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution  and  use  in  source  and binary  forms,  with  or  without
 * modification, are permitted provided that the following conditions are met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice and this list of conditions.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice and  this list of  conditions in the  documentation and/or
 *      other materials provided with the distribution.
 *
 * THE SOFTWARE  IS PROVIDED "AS IS"  AND THE AUTHOR  DISCLAIMS ALL WARRANTIES
 * WITH  REGARD   TO  THIS  SOFTWARE  INCLUDING  ALL   IMPLIED  WARRANTIES  OF
 * MERCHANTABILITY AND  FITNESS.  IN NO EVENT  SHALL THE AUTHOR  BE LIABLE FOR
 * ANY  SPECIAL, DIRECT,  INDIRECT, OR  CONSEQUENTIAL DAMAGES  OR  ANY DAMAGES
 * WHATSOEVER  RESULTING FROM  LOSS OF  USE, DATA  OR PROFITS,  WHETHER  IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR  OTHER TORTIOUS ACTION, ARISING OUT OF OR
 * IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
#ifndef _VELODYNE_CLIENT_H
#define _VELODYNE_CLIENT_H

/* External Genom headers */
#include <pomStruct.h>

/******************************************************************************/
/* Exported poster structure */

#define VELODYNE_3D_IMAGE_HEIGHT 64
#define VELODYNE_3D_IMAGE_WIDTH  4750

#define velodyne3DImageAt(a,i,j) \
    (((a)->points) + ((i) * (VELODYNE_3D_IMAGE_WIDTH)) + (j))

typedef enum velodyne3DPointStatus {
  VELODYNE_BAD_3DPOINT,
  VELODYNE_GOOD_3DPOINT
} velodyne3DPointStatus;

typedef struct velodyne3DPoint {
  float                 coordinates[3];
  short                 intensity;
  velodyne3DPointStatus status;
} velodyne3DPoint;

typedef struct velodyne3DImage {
  POM_SENSOR_POS  position; /* The pom-position at the time the acquisition
                               request was made */
  velodyne3DPoint points[VELODYNE_3D_IMAGE_HEIGHT*VELODYNE_3D_IMAGE_WIDTH];
  int             height;
  int             width;
  int             maxScanWidth;
} velodyne3DImage;

#endif
